sha2.c File Reference
`#include "defs.h"`
`#include <string.h>`
`#include <assert.h>`
`#include "sha2.h"`

Go to the source code of this file.

## Macros

#define | SHA256_SHORT_BLOCK_LENGTH (SHA256_BLOCK_LENGTH - 8)
#define | SHA384_SHORT_BLOCK_LENGTH (SHA384_BLOCK_LENGTH - 16)
#define | SHA512_SHORT_BLOCK_LENGTH (SHA512_BLOCK_LENGTH - 16)
#define | ULL(number) (uint64_t)(number)
#define | REVERSE32(w, x)
#define | REVERSE64(w, x)
#define | ADDINC128(w, n)
#define | SHA2_USE_MEMSET_MEMCPY 1
#define | MEMSET_BZERO(p, l) memset((p), 0, (l))
#define | MEMCPY_BCOPY(d, s, l) memcpy((d), (s), (l))
#define | R(b, x) ((x) >> (b))
#define | S32(b, x) (((x) >> (b)) | ((x) << (32 - (b))))
#define | S64(b, x) (((x) >> (b)) | ((x) << (64 - (b))))
#define | Ch(x, y, z) (((x) & (y)) ^ ((~(x)) & (z)))
#define | Maj(x, y, z) (((x) & (y)) ^ ((x) & (z)) ^ ((y) & (z)))
#define | Sigma0_256(x) (S32(2, (x)) ^ S32(13, (x)) ^ S32(22, (x)))
#define | Sigma1_256(x) (S32(6, (x)) ^ S32(11, (x)) ^ S32(25, (x)))
#define | sigma0_256(x) (S32(7, (x)) ^ S32(18, (x)) ^ R(3 , (x)))
#define | sigma1_256(x) (S32(17, (x)) ^ S32(19, (x)) ^ R(10, (x)))
#define | Sigma0_512(x) (S64(28, (x)) ^ S64(34, (x)) ^ S64(39, (x)))
#define | Sigma1_512(x) (S64(14, (x)) ^ S64(18, (x)) ^ S64(41, (x)))
#define | sigma0_512(x) (S64( 1, (x)) ^ S64( 8, (x)) ^ R( 7, (x)))
#define | sigma1_512(x) (S64(19, (x)) ^ S64(61, (x)) ^ R( 6, (x)))

## Typedefs

typedef u_int8_t | sha2_byte
typedef u_int32_t | sha2_word32
typedef u_int64_t | sha2_word64

## Functions

void | SHA512_Last (SHA512_CTX *)
void | SHA256_Transform (SHA256_CTX *, const sha2_word32 *)
void | SHA512_Transform (SHA512_CTX *, const sha2_word64 *)
void | SHA256_Init (SHA256_CTX *context)
void | SHA256_Update (SHA256_CTX *context, const sha2_byte *data, size_t len)
void | SHA256_Final (sha2_byte digest[], SHA256_CTX *context)
char * | SHA256_End (SHA256_CTX *context, char buffer[])
char * | SHA256_Data (const sha2_byte *data, size_t len, char digest[SHA256_DIGEST_STRING_LENGTH])
void | SHA512_Init (SHA512_CTX *context)
void | SHA512_Update (SHA512_CTX *context, const sha2_byte *data, size_t len)
void | SHA512_Final (sha2_byte digest[], SHA512_CTX *context)
char * | SHA512_End (SHA512_CTX *context, char buffer[])
char * | SHA512_Data (const sha2_byte *data, size_t len, char digest[SHA512_DIGEST_STRING_LENGTH])
void | SHA384_Init (SHA384_CTX *context)
void | SHA384_Update (SHA384_CTX *context, const sha2_byte *data, size_t len)
void | SHA384_Final (sha2_byte digest[], SHA384_CTX *context)
char * | SHA384_End (SHA384_CTX *context, char buffer[])
char * | SHA384_Data (const sha2_byte *data, size_t len, char digest[SHA384_DIGEST_STRING_LENGTH])

## Variables

static const sha2_word32 | K256 [64]
static const sha2_word32 | sha256_initial_hash_value [8]
static const sha2_word64 | K512 [80]
static const sha2_word64 | sha384_initial_hash_value [8]
static const sha2_word64 | sha512_initial_hash_value [8]
static const char * | sha2_hex_digits = "0123456789abcdef"

## Macro Definition Documentation

#define ADDINC128 | ( |  | w,
|  |  | n
| ) |  |

Value:
{ \
(w)[0] += (sha2_word64)(n); \
if ((w)[0] < (n)) { \
(w)[1]++; \
} \
}

Definition at line 158 of file sha2.c.

Referenced by SHA512_Update().

#define Ch | ( |  | x,
|  |  | y,
|  |  | z
| ) |  | (((x) & (y)) ^ ((~(x)) & (z)))

Definition at line 210 of file sha2.c.

Referenced by SHA256_Transform(), and SHA512_Transform().

#define Maj | ( |  | x,
|  |  | y,
|  |  | z
| ) |  | (((x) & (y)) ^ ((x) & (z)) ^ ((y) & (z)))

Definition at line 211 of file sha2.c.

Referenced by SHA256_Transform(), and SHA512_Transform().

#define MEMCPY_BCOPY | ( |  | d,
|  |  | s,
|  |  | l
| ) |  | memcpy((d), (s), (l))

Definition at line 185 of file sha2.c.

Referenced by SHA256_Final(), SHA256_Init(), SHA256_Update(), SHA384_Final(), SHA384_Init(), SHA512_Final(), SHA512_Init(), and SHA512_Update().

#define MEMSET_BZERO | ( |  | p,
|  |  | l
| ) |  | memset((p), 0, (l))

Definition at line 184 of file sha2.c.

Referenced by SHA256_End(), SHA256_Final(), SHA256_Init(), SHA384_End(), SHA384_Final(), SHA384_Init(), SHA512_End(), SHA512_Final(), SHA512_Init(), and SHA512_Last().

#define R | ( |  | b,
|  |  | x
| ) |  | ((x) >> (b))

Definition at line 203 of file sha2.c.

Referenced by des_cipher(), and ruby_qsort().

#define REVERSE32 | ( |  | w,
|  |  | x
| ) |  |

Value:
{ \
sha2_word32 tmp = (w); \
tmp = (tmp >> 16) | (tmp << 16); \
(x) = ((tmp & 0xff00ff00UL) >> 8) | ((tmp & 0x00ff00ffUL) << 8); \
}

Definition at line 138 of file sha2.c.

Referenced by SHA256_Final(), and SHA256_Transform().

#define REVERSE64 | ( |  | w,
|  |  | x
| ) |  |

Value:
{ \
sha2_word64 tmp = (w); \
tmp = (tmp >> 32) | (tmp << 32); \
tmp = ((tmp & ULL(0xff00ff00ff00ff00)) >> 8) | \
((tmp & ULL(0x00ff00ff00ff00ff)) << 8); \
(x) = ((tmp & ULL(0xffff0000ffff0000)) >> 16) | \
((tmp & ULL(0x0000ffff0000ffff)) << 16); \
}

Definition at line 143 of file sha2.c.

Referenced by SHA256_Final(), SHA384_Final(), SHA512_Final(), SHA512_Last(), and SHA512_Transform().

#define S32 | ( |  | b,
|  |  | x
| ) |  | (((x) >> (b)) | ((x) << (32 - (b))))

Definition at line 205 of file sha2.c.

#define S64 | ( |  | b,
|  |  | x
| ) |  | (((x) >> (b)) | ((x) << (64 - (b))))

Definition at line 207 of file sha2.c.

#define SHA256_SHORT_BLOCK_LENGTH (SHA256_BLOCK_LENGTH - 8)

Definition at line 126 of file sha2.c.

Referenced by SHA256_Final().

#define SHA2_USE_MEMSET_MEMCPY 1

Definition at line 176 of file sha2.c.

#define SHA384_SHORT_BLOCK_LENGTH (SHA384_BLOCK_LENGTH - 16)

Definition at line 127 of file sha2.c.

#define SHA512_SHORT_BLOCK_LENGTH (SHA512_BLOCK_LENGTH - 16)

Definition at line 128 of file sha2.c.

Referenced by SHA512_Last().

#define Sigma0_256 | ( |  | x | ) | (S32(2, (x)) ^ S32(13, (x)) ^ S32(22, (x)))

Definition at line 214 of file sha2.c.

Referenced by SHA256_Transform().

#define sigma0_256 | ( |  | x | ) | (S32(7, (x)) ^ S32(18, (x)) ^ R(3 , (x)))

Definition at line 216 of file sha2.c.

#define Sigma0_512 | ( |  | x | ) | (S64(28, (x)) ^ S64(34, (x)) ^ S64(39, (x)))

Definition at line 220 of file sha2.c.

Referenced by SHA512_Transform().

#define sigma0_512 | ( |  | x | ) | (S64( 1, (x)) ^ S64( 8, (x)) ^ R( 7, (x)))

Definition at line 222 of file sha2.c.

#define Sigma1_256 | ( |  | x | ) | (S32(6, (x)) ^ S32(11, (x)) ^ S32(25, (x)))

Definition at line 215 of file sha2.c.

Referenced by SHA256_Transform().

#define sigma1_256 | ( |  | x | ) | (S32(17, (x)) ^ S32(19, (x)) ^ R(10, (x)))

Definition at line 217 of file sha2.c.

#define Sigma1_512 | ( |  | x | ) | (S64(14, (x)) ^ S64(18, (x)) ^ S64(41, (x)))

Definition at line 221 of file sha2.c.

Referenced by SHA512_Transform().

#define sigma1_512 | ( |  | x | ) | (S64(19, (x)) ^ S64(61, (x)) ^ R( 6, (x)))

Definition at line 223 of file sha2.c.

#define ULL | ( |  | number | ) | (uint64_t)(number)

Definition at line 134 of file sha2.c.

## Typedef Documentation

typedef u_int8_t sha2_byte

Definition at line 117 of file sha2.c.

typedef u_int32_t sha2_word32

Definition at line 118 of file sha2.c.

typedef u_int64_t sha2_word64

Definition at line 119 of file sha2.c.

## Function Documentation

char* SHA256_Data | ( | const sha2_byte * | data,
|  | size_t | len,
|  | char | digest[SHA256_DIGEST_STRING_LENGTH]
| ) |  |

Definition at line 662 of file sha2.c.

References SHA256_End(), SHA256_Init(), and SHA256_Update().

char* SHA256_End | ( | SHA256_CTX * | context,
|  | char | buffer[]
| ) |  |

Definition at line 640 of file sha2.c.

References assert, i, MEMSET_BZERO, SHA256_DIGEST_LENGTH, SHA256_Final(), and sha2_hex_digits.

Referenced by SHA256_Data().

void SHA256_Final | ( | sha2_byte | digest[],
|  | SHA256_CTX * | context
| ) |  |

Definition at line 577 of file sha2.c.

References assert, _SHA256_CTX::bitcount, _SHA256_CTX::buffer, MEMCPY_BCOPY, MEMSET_BZERO, REVERSE32, REVERSE64, SHA256_BLOCK_LENGTH, SHA256_DIGEST_LENGTH, SHA256_SHORT_BLOCK_LENGTH, SHA256_Transform(), and _SHA256_CTX::state.

Referenced by SHA256_End().

void SHA256_Init | ( | SHA256_CTX * | context | ) |

Definition at line 344 of file sha2.c.

References _SHA256_CTX::bitcount, _SHA256_CTX::buffer, MEMCPY_BCOPY, MEMSET_BZERO, SHA256_BLOCK_LENGTH, SHA256_DIGEST_LENGTH, sha256_initial_hash_value, and _SHA256_CTX::state.

Referenced by SHA256_Data().

void SHA256_Transform | ( | SHA256_CTX * | context,
|  | const sha2_word32 * | data
| ) |  |

Definition at line 448 of file sha2.c.

References _SHA256_CTX::buffer, Ch, K256, Maj, REVERSE32, Sigma0_256, Sigma1_256, _SHA256_CTX::state, T1, and T2.

Referenced by SHA256_Final(), and SHA256_Update().

void SHA256_Update | ( | SHA256_CTX * | context,
|  | const sha2_byte * | data,
|  | size_t | len
| ) |  |

Definition at line 528 of file sha2.c.

References assert, _SHA256_CTX::bitcount, _SHA256_CTX::buffer, MEMCPY_BCOPY, SHA256_BLOCK_LENGTH, and SHA256_Transform().

Referenced by SHA256_Data().

char* SHA384_Data | ( | const sha2_byte * | data,
|  | size_t | len,
|  | char | digest[SHA384_DIGEST_STRING_LENGTH]
| ) |  |

Definition at line 1065 of file sha2.c.

References SHA384_End(), SHA384_Init(), and SHA384_Update().

char* SHA384_End | ( | SHA384_CTX * | context,
|  | char | buffer[]
| ) |  |

Definition at line 1043 of file sha2.c.

References assert, i, MEMSET_BZERO, sha2_hex_digits, SHA384_DIGEST_LENGTH, and SHA384_Final.

Referenced by SHA384_Data().

void SHA384_Final | ( | sha2_byte | digest[],
|  | SHA384_CTX * | context
| ) |  |

Definition at line 1014 of file sha2.c.

References assert, MEMCPY_BCOPY, MEMSET_BZERO, REVERSE64, SHA384_DIGEST_LENGTH, SHA512_Last(), and _SHA512_CTX::state.

void SHA384_Init | ( | SHA384_CTX * | context | ) |

Definition at line 1001 of file sha2.c.

References _SHA512_CTX::bitcount, _SHA512_CTX::buffer, MEMCPY_BCOPY, MEMSET_BZERO, SHA384_BLOCK_LENGTH, sha384_initial_hash_value, SHA512_DIGEST_LENGTH, and _SHA512_CTX::state.

Referenced by SHA384_Data().

void SHA384_Update | ( | SHA384_CTX * | context,
|  | const sha2_byte * | data,
|  | size_t | len
| ) |  |

Definition at line 1010 of file sha2.c.

References SHA512_Update().

Referenced by SHA384_Data().

char* SHA512_Data | ( | const sha2_byte * | data,
|  | size_t | len,
|  | char | digest[SHA512_DIGEST_STRING_LENGTH]
| ) |  |

Definition at line 991 of file sha2.c.

References SHA512_End(), SHA512_Init(), and SHA512_Update().

char* SHA512_End | ( | SHA512_CTX * | context,
|  | char | buffer[]
| ) |  |

Definition at line 969 of file sha2.c.

References assert, i, MEMSET_BZERO, sha2_hex_digits, SHA512_DIGEST_LENGTH, and SHA512_Final().

Referenced by SHA512_Data().

void SHA512_Final | ( | sha2_byte | digest[],
|  | SHA512_CTX * | context
| ) |  |

Definition at line 940 of file sha2.c.

References assert, MEMCPY_BCOPY, MEMSET_BZERO, REVERSE64, SHA512_DIGEST_LENGTH, SHA512_Last(), and _SHA512_CTX::state.

Referenced by SHA512_End().

void SHA512_Init | ( | SHA512_CTX * | context | ) |

Definition at line 672 of file sha2.c.

References _SHA512_CTX::bitcount, _SHA512_CTX::buffer, MEMCPY_BCOPY, MEMSET_BZERO, SHA512_BLOCK_LENGTH, SHA512_DIGEST_LENGTH, sha512_initial_hash_value, and _SHA512_CTX::state.

Referenced by SHA512_Data().

void SHA512_Last | ( | SHA512_CTX * | context | ) |

Definition at line 899 of file sha2.c.

References _SHA512_CTX::bitcount, _SHA512_CTX::buffer, MEMSET_BZERO, REVERSE64, SHA512_BLOCK_LENGTH, SHA512_SHORT_BLOCK_LENGTH, and SHA512_Transform().

Referenced by SHA384_Final(), and SHA512_Final().

void SHA512_Transform | ( | SHA512_CTX * | context,
|  | const sha2_word64 * | data
| ) |  |

Definition at line 772 of file sha2.c.

References _SHA512_CTX::buffer, Ch, K512, Maj, REVERSE64, Sigma0_512, Sigma1_512, _SHA512_CTX::state, T1, and T2.

Referenced by SHA512_Last(), and SHA512_Update().

void SHA512_Update | ( | SHA512_CTX * | context,
|  | const sha2_byte * | data,
|  | size_t | len
| ) |  |

Definition at line 850 of file sha2.c.

References ADDINC128, assert, _SHA512_CTX::bitcount, _SHA512_CTX::buffer, MEMCPY_BCOPY, SHA512_BLOCK_LENGTH, and SHA512_Transform().

Referenced by SHA384_Update(), and SHA512_Data().

## Variable Documentation

const sha2_word32 K256[64]

static

Initial value:
= {
0x428a2f98UL, 0x71374491UL, 0xb5c0fbcfUL, 0xe9b5dba5UL,
0x3956c25bUL, 0x59f111f1UL, 0x923f82a4UL, 0xab1c5ed5UL,
0xd807aa98UL, 0x12835b01UL, 0x243185beUL, 0x550c7dc3UL,
0x72be5d74UL, 0x80deb1feUL, 0x9bdc06a7UL, 0xc19bf174UL,
0xe49b69c1UL, 0xefbe4786UL, 0x0fc19dc6UL, 0x240ca1ccUL,
0x2de92c6fUL, 0x4a7484aaUL, 0x5cb0a9dcUL, 0x76f988daUL,
0x983e5152UL, 0xa831c66dUL, 0xb00327c8UL, 0xbf597fc7UL,
0xc6e00bf3UL, 0xd5a79147UL, 0x06ca6351UL, 0x14292967UL,
0x27b70a85UL, 0x2e1b2138UL, 0x4d2c6dfcUL, 0x53380d13UL,
0x650a7354UL, 0x766a0abbUL, 0x81c2c92eUL, 0x92722c85UL,
0xa2bfe8a1UL, 0xa81a664bUL, 0xc24b8b70UL, 0xc76c51a3UL,
0xd192e819UL, 0xd6990624UL, 0xf40e3585UL, 0x106aa070UL,
0x19a4c116UL, 0x1e376c08UL, 0x2748774cUL, 0x34b0bcb5UL,
0x391c0cb3UL, 0x4ed8aa4aUL, 0x5b9cca4fUL, 0x682e6ff3UL,
0x748f82eeUL, 0x78a5636fUL, 0x84c87814UL, 0x8cc70208UL,
0x90befffaUL, 0xa4506cebUL, 0xbef9a3f7UL, 0xc67178f2UL
}

Definition at line 237 of file sha2.c.

Referenced by SHA256_Transform().

const sha2_word64 K512[80]

static

Definition at line 269 of file sha2.c.

Referenced by SHA512_Transform().

const sha2_word32 sha256_initial_hash_value[8]

static

Initial value:
= {
0x6a09e667UL,
0xbb67ae85UL,
0x3c6ef372UL,
0xa54ff53aUL,
0x510e527fUL,
0x9b05688cUL,
0x1f83d9abUL,
0x5be0cd19UL
}

Definition at line 257 of file sha2.c.

Referenced by SHA256_Init().

const char* sha2_hex_digits = "0123456789abcdef"

static

Definition at line 340 of file sha2.c.

Referenced by SHA256_End(), SHA384_End(), and SHA512_End().

const sha2_word64 sha384_initial_hash_value[8]

static

Initial value:
= {
ULL(0xcbbb9d5dc1059ed8),
ULL(0x629a292a367cd507),
ULL(0x9159015a3070dd17),
ULL(0x152fecd8f70e5939),
ULL(0x67332667ffc00b31),
ULL(0x8eb44a8768581511),
ULL(0xdb0c2e0d64f98fa7),
}

Definition at line 313 of file sha2.c.

Referenced by SHA384_Init().

const sha2_word64 sha512_initial_hash_value[8]

static

Initial value:
= {
ULL(0x6a09e667f3bcc908),
ULL(0xbb67ae8584caa73b),
ULL(0x3c6ef372fe94f82b),
ULL(0xa54ff53a5f1d36f1),
ULL(0x510e527fade682d1),
ULL(0x9b05688c2b3e6c1f),
ULL(0x1f83d9abfb41bd6b),
}

Definition at line 325 of file sha2.c.

Referenced by SHA512_Init().